Unit QTSHR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QTSHR(var RINT :Array of Real; H1 :Real; H2 :Real;
                var F :Array of Real; N :Integer; M :Integer);

implementation

procedure QTSHR(var RINT :Array of Real; H1 :Real; H2 :Real;
                var F :Array of Real; N :Integer; M :Integer);
var
I,J :Integer;
A1,A2,A3,B1,B2,B3,C,C2,F12 :Real;
A :Array [0..3] of Real;
label
_10,_20,_30,_40,_50,_60,_70;
{  -  FORTRAN }
function AR(R1: Real; R2: Real; R3: Real; R4: Real): Real;
begin
Result := B1*(R1 - R3) + B2*R2 + B3*R4;
end;
{   - }
begin
C := H1*H2/9.0;
C2 := C/4.0;
B1 := 5.0/16.0;
B2 := 15.0/16.0;
B3 := 1.0/16.0;
for J:=1 to 4 do
 begin
  A[J-1] := AR(F[0+(J-1)*N],F[1+(J-1)*N],F[2+(J-1)*N],F[3+(J-1)*N]);
_10:
 end;
F12 := AR(A[0],A[1],A[2],A[3]);
A1 := AR(F[0+0*N],F[0+1*N],F[0+2*N],F[0+3*N]);
A2 := AR(F[1+0*N],F[1+1*N],F[1+2*N],F[1+3*N]);
RINT[1+1*N] := (F[0+0*N] + F[1+0*N] + F[0+1*N] + F[1+1*N] + 16.0*F12 +
    4.0*(A1 + A2 + A[0] + A[1]))*C2;
C2 := C/2.0;
for J:=1 to M do
 begin
  RINT[0+(J-1)*N] := 0.0;
_20:
 end;
RINT[1+0*N] := 0.0;
for J:=3 to M do
 begin
  A[2] := AR(F[0+(J-1)*N],F[1+(J-1)*N],F[2+(J-1)*N],F[3+(J-1)*N]);
  RINT[1+(J-1)*N] := RINT[1+(J-3)*N] + (F[0+(J-3)*N] + F[1+(J-3)*N] + F[0+(J-1)*N] +
    F[1+(J-1)*N] + 16.0*A[1] + 4.0*(A[0] + A[2] + F[0+(J-2)*N]
    + F[1+(J-2)*N]))*C2;
  A[0] := A[1];
  A[1] := A[2];
_30:
 end;
for I:=3 to N do
 begin
  A3 := AR(F[(I-1)+0*N],F[(I-1)+1*N],F[(I-1)+2*N],F[(I-1)+3*N]);
  RINT[(I-1)+0*N] := 0.0;
  RINT[(I-1)+1*N] := (F[(I-3)+0*N] + F[(I-3)+1*N] + F[(I-1)+0*N] + F[(I-1)+1*N] + 16.0*
    A2 + 4.0*(A1 + A3 + F[(I-2)+0*N] + F[(I-2)+1*N]))*C2;
  A1 := A2;
  A2 := A3;
  for J:=3 to M do
   begin
    RINT[(I-1)+(J-1)*N] := RINT[(I-1)+(J-3)*N] + (F[(I-1)+(J-1)*N] + F[(I-1)+(J-3)*N] + F[(I-3)+(J-1)*N]
    + F[(I-3)+(J-3)*N] + 16.0*F[(I-2)+(J-2)*N] + 4.0*(F[(I-1-1)+(
    J-1)*N] + F[(I-2)+(J-3)*N] + F[(I-1)+(J-2)*N] + F[(I-3)+(J-2)*N]))*C;
_40:
   end;
_50:
 end;
for I:=3 to N do
 begin
  for J:=3 to M do
   begin
    RINT[(I-1)+(J-1)*N] := RINT[(I-1)+(J-1)*N] + RINT[(I-3)+(J-1)*N];
_60:
   end;
_70:
 end;
end;

end.
